Commit 55bbc8ff authored by Stefano Brivio's avatar Stefano Brivio Committed by David S. Miller

selftests: pmtu: Allow selection of single tests

As number of tests is growing, it's quite convenient to allow
single tests to be run.

Display usage when the script is run with any invalid argument,
keep existing semantics when no arguments are passed so that
automated runs won't break.

Instead of just looping on the list of requested tests, if any,
check first that they exist, and go through them in a nested
loop to keep the existing way to display test descriptions.
Signed-off-by: default avatarStefano Brivio <sbrivio@redhat.com>
Reviewed-by: default avatarSabrina Dubroca <sd@queasysnail.net>
Signed-off-by: default avatarDavid S. Miller <davem@davemloft.net>
parent 2527e403
...@@ -641,6 +641,20 @@ test_pmtu_vti6_link_change_mtu() { ...@@ -641,6 +641,20 @@ test_pmtu_vti6_link_change_mtu() {
return ${fail} return ${fail}
} }
usage() {
echo
echo "$0 [TEST]..."
echo "If no TEST argument is given, all tests will be run."
echo
echo "Available tests${tests}"
exit 1
}
for arg do
# Check first that all requested tests are available before running any
command -v > /dev/null "test_${arg}" || { echo "=== Test ${arg} not found"; usage; }
done
trap cleanup EXIT trap cleanup EXIT
exitcode=0 exitcode=0
...@@ -650,6 +664,13 @@ IFS=" ...@@ -650,6 +664,13 @@ IFS="
for t in ${tests}; do for t in ${tests}; do
[ $desc -eq 0 ] && name="${t}" && desc=1 && continue || desc=0 [ $desc -eq 0 ] && name="${t}" && desc=1 && continue || desc=0
run_this=1
for arg do
[ "${arg}" = "${name}" ] && run_this=1 && break
run_this=0
done
[ $run_this -eq 0 ] && continue
( (
unset IFS unset IFS
eval test_${name} eval test_${name}
......
Markdown is supported
0%
or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment